routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware'=>'language'],function () {
    Route::get('/', 'PostsController@index')->name('dashboard')->middleware('auth');
    Route::resource('posts', 'PostsController')->except('create', 'show', 'destroy')->middleware('auth');
    Auth::routes();
    Route::get('/home', 'HomeController@index')->name('home');
});

Route::get('language/{locale}', 'LanguageSwitcherController@switcher')
    ->name('language.switcher')
    ->where('locale', 'ru|en');

app/Post.php
<?php

namespace App;
use Astrotomic\Translatable\Contracts\Translatable as TranslatableContract;
use Astrotomic\Translatable\Translatable;
use Illuminate\Database\Eloquent\Model;

class Post extends Model implements TranslatableContract
{
    use Translatable;

    public $translatedAttributes = ['content'];
    protected $fillable = ['user_id'];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user() {
        return $this->belongsTo(User::class);
    }
}

app/PostTranslation.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;


class PostTranslation extends Model
{
    public $timestamps = false;

    protected $fillable = ['content'];
}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function posts() {
        return $this->hasMany(Post::class);
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/LanguageSwitcherController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class LanguageSwitcherController extends Controller
{
    /**
     * @param Request $request
     * @param string $locale
     * @return \Illuminate\Http\RedirectResponse
     */
    public function switcher(Request $request, string $locale)
    {
        $request->session()->put('locale', $locale);
        return back();
    }
}

app/Http/Controllers/PostsController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PostRequest;
use App\Post;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PostsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        $posts = Post::all();
        return view('posts.index', compact('posts'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param PostRequest $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(PostRequest $request)
    {
        Auth::user();
        $post = new Post();
        $post->translateOrNew('ru')->content = $request->get('content');
        foreach(['en', 'fr', 'es', 'de'] as $locale) {
            $post->translateOrNew($locale)->content = '';
        }
        $post->user_id = $request->user()->id;
        $post->save();
        return redirect()->route('posts.index');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function edit($id)
    {
        $post = Post::findOrFail($id);
        return view('posts.edit', compact('post'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Request $request, Post $post)
    {
        foreach(['en', 'fr', 'es', 'de'] as $locale) {
            if(!$request->get($locale)) {
                $post->translateOrNew($locale)->content = '';
            }
            else {
                $post->translateOrNew($locale)->content = $request->get($locale);
            }
        }
        $post->update();
        return redirect()->route('posts.index');
    }
}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>Homework 68</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    TranslationShop
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                        <li class="nav-item ml-2 pb-1 pt-1">
                            <select class="custom-select" style="font-size: 12px" onchange="location = this.value;">
                                <option @if (session('locale') == 'en') selected @endif value="{{route('language.switcher', 'en')}}">
                                    EN
                                </option>
                                <option @if (session('locale') == 'ru') selected @endif value="{{route('language.switcher', 'ru')}}">
                                    RU
                                </option>
                            </select>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/posts/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        @if(Auth::user()->id == $post->user_id)
            <div class="row mb-3">
                <h5>@lang('Переводы для') '{{$post->translate('ru')->content}}':</h5>
            </div>
            <div class="row">
                <table class="table table-bordered">
                    <thead class="thead-light">
                    <tr class="text-center">
                        <th scope="col">@lang('Английский')</th>
                        <th scope="col">@lang('Французский')</th>
                        <th scope="col">@lang('Испанский')</th>
                        <th scope="col">@lang('Немецкий')</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td>{{$post->translate('en')->content}}</td>
                        <td>{{$post->translate('fr')->content}}</td>
                        <td>{{$post->translate('es')->content}}</td>
                        <td>{{$post->translate('de')->content}}</td>
                    </tr>
                    </tbody>
                </table>
            </div>
            <div class="row"><a class="pl-4" href="{{route('posts.index')}}">@lang('Назад')</a></div>

        @else
            <div class="row mb-3">
                <h5>@lang('Введите перевод для') '{{$post->translate('ru')->content}}':</h5>
            </div>
            <form method="post" action="{{route('posts.update', ['post' => $post])}}">
                @method('PUT')
                @csrf
                <div class="form-row">
                    <div class="form-group col-md-4">
                        <label for="en"><b>@lang('Английский')</b></label>
                        <input type="text" class="form-control" id="en"
                               name="en"
                               value="{{$post->translate('en')->content}}">
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-group col-md-4">
                        <label for="fr"><b>@lang('Французский')</b></label>
                        <input type="text" class="form-control" id="fr"
                               name="fr"
                               value="{{$post->translate('fr')->content}}">
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-group col-md-4">
                        <label for="es"><b>@lang('Испанский')</b></label>
                        <input type="text" class="form-control" id="es"
                               name="es"
                               value="{{$post->translate('es')->content}}">
                    </div>
                </div>
                <div class="form-row">
                    <div class="form-group col-md-4">
                        <label for="de"><b>@lang('Немецкий')</b></label>
                        <input type="text" class="form-control" id="de"
                               name="de"
                               value="{{$post->translate('de')->content}}">
                        @error('de')
                        <p class="error">{{ $message }}</p>
                        @enderror
                    </div>
                </div>
                <div class="form-group">
                    <button type="submit" class="btn btn-primary">@lang('Сохранить переводы')</button>
                    <a class="pl-4" href="{{route('posts.index')}}">@lang('Назад')</a>
                </div>
            </form>
        @endif
    </div>
@endsection

resources/views/posts/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row mb-3">
            <h5>@lang('Введите фразу на русском для перевода'):</h5>
        </div>

        @foreach($posts as $post)
            <div class="row">
                <a href="{{route('posts.edit', ['post' => $post])}}">{{$post->translate('ru')->content}}</a>
            </div>
        @endforeach

        <form method="post" action="{{route('posts.store')}}">
            @csrf
            <div class="form-row mt-5">
                <div class="form-group col-md-8">
                    <label for="content"><b>@lang('Ваша фраза'):</b></label><span class="text-danger">*</span>
                    <textarea class="form-control @error('content') is-invalid @enderror" id="content"
                              name="content"></textarea>
                    @error('content')
                    <p class="error">{{ $message }}</p>
                    @enderror
                </div>
            </div>
            <button type="submit" class="btn btn-primary">@lang('Добавить')</button>
        </form>
    </div>
@endsection